unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ScktComp, ExtCtrls, ComCtrls, TeEngine, Series, TeeProcs, Chart;

type
  TfrmMain = class(TForm)
    FingerPrint: TClientSocket;
    AdrEdt: TEdit;
    LogMemo: TMemo;
    Label1: TLabel;
    AnswerMemo: TMemo;
    ScanBtn: TButton;
    PortEdt: TEdit;
    StatusBar: TStatusBar;
    Panel1: TPanel;
    HostLbl: TLabel;
    PortLbl: TLabel;
    FP: TMemo;
    SaveBtn: TButton;
    ResetBtn: TButton;
    Splitter1: TSplitter;
    SaveCheckBtn: TButton;
    Timer1: TTimer;
    VerboseBox: TCheckBox;
    Splitter2: TSplitter;
    Label2: TLabel;
    LocationEdt: TEdit;
    Label3: TLabel;
    procedure ScanBtnClick(Sender: TObject);
    procedure FingerPrintConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure FingerPrintRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormCreate(Sender: TObject);
    procedure FingerPrintWrite(Sender: TObject; Socket: TCustomWinSocket);
    procedure Button1Click(Sender: TObject);
    procedure FingerPrintDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure SaveBtnClick(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
    function CheckHeaders(Headers,TNum: String): String;
    procedure SaveCheckBtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure AddToTotal(ServerType: String);
    procedure GraphClick(Sender: TObject);
    procedure FingerPrintError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
  private
    counter,CheckNum,N_of_tests: Integer;
    HeaderT, HeaderCnt: TStringList;
  public
    Host: String;
  end;

var
  frmMain: TfrmMain;

implementation
uses FingerPrintThreadSource;
{$R *.DFM}

procedure TfrmMain.AddToTotal(ServerType: String);
Var
I: Integer;
Found: Boolean;
begin
        for i:=0 to HeaderT.Count-1 do begin
                if HeaderT[I]=ServerType then begin
                        HeaderCnt[I]:=IntToStr(StrToInt(HeaderCnt[I])+1);
                         Found:=True;
                end;

        end;
        if Found=False then begin
                HeaderT.Add(ServerType);
                HeaderCnt.Add('1');
        end;

end;
function TfrmMain.CheckHeaders(Headers,TNum: String): String;
var
R,LineNum, Counter,I,J,K: Integer;
AnsHeaders,FPHeaders,Lines,Num: TStringList;
ServerType,S,Header,A: String;
Found: Boolean;
label FoundServerType,NotYetFound;
begin
Found:=True;
Lines:=TStringList.Create;
Lines.Text:=Headers;
FPHeaders:=TStringList.Create;
AnsHeaders:=TStringList.Create;
A:=Lines[0];
if Pos('T',TNum)=1 then
        for i:=0 to Lines.Count-1 do
                if Pos(': ',Lines[I])=0 then begin
                        Lines[I]:='<<EMPTY>>';
                end;

                // Analyse FingerPrints and add them to AnsHeaders
if Pos('A',TNum)=1 then begin
        Found:=False;
        for K:=0 to FP.Lines.Count-1 do begin
                LineNum:=K;
                if Pos(TNum,Fp.Lines[K])=1 then begin
                        S:=FP.Lines[K];
                        J:=0;
                        while J<Length(S)-1 do
                                if S[J]='"' then begin
                                        inc(J);
                                        Header:='';
                                        while (S[J] <> '"') do begin
                                                Header:=Header+S[J];
                                                inc(J);
                                                if S[J]='"' then
                                                        if A=Header then begin
//**
                            Found:=True;
                            R:=LineNum;
                            while R>0 do begin
                                    if Pos('("',FP.Lines[R]) <> 3 then begin
                                            ServerType:=FP.Lines[R];
                                            Break;
                                    end;
                            dec(R);
                            end;
                            AddToTotal(ServerType);
                            if Result <> '' then
                                    Result:= Result +' or '+ ServerType
                            else
                                    Result:=ServerType;
                            end;
 //***
//                                                       end;
                                        end;
                                end else inc(J);
                        end;
        end;
end else begin
if Pos ('^',Tnum)=1 then
        Delete(TNum,1,1);
end;
for K:=0 to FP.Lines.Count-1 do begin
        FPHeaders.Clear;
        AnsHeaders.Clear;
        Num:=TStringLIst.Create;
        Num.Clear;
        // FP Headeri
        if Pos(TNum,FP.Lines[K])=1 then begin
                LineNum:=K;
                S:=FP.Lines[K];
                J:=0;
                while J<Length(S)-1 do
                        if S[J]='"' then begin
                                inc(J);
                                while (S[J] <> '"') and (S[J] <> ',') do begin
                                        Header:=Header+S[J];
                                        inc(J);
                                        if S[J]='"' then begin
                                                FPHeaders.Add(Header);
                                                Header:='';
                                        end;
                                end;
                        end else inc(J);
       end;
        // Primljeni Headeri
        for I:=0 to Lines.Count -1 do begin
                J:=0;
                S:='';
                while J< Pos(':',Lines[I])-1 do begin
                        inc(J);
                        S:=S+Lines[I][J];
                end;
                if J>0 then
                                AnsHeaders.Add(S)
        end;

        //Ajmo malo usporedivat
        Num:=TStringList.Create;
        for i:=0 to FPHeaders.Count -1 do begin
                for J:=0 to AnsHeaders.Count-1 do
                        if AnsHeaders[J]=FPHeaders[I] then
                                Num.Add(IntToStr(J));
        end;

        //Je li u redoslijedu
        for I:=0 to Num.Count-1 do begin
                for J:=I to Num.Count-1 do
                        if StrToInt(Num[I])>StrToInt(Num[J]) then begin
                                Found:=False;
                                goto NotYetFound;
                        end;
        if (Num.Count=FPHeaders.Count) and (I=Num.Count-1) and (J=Num.Count) then begin
//***
                Found:=True;
                R:=LineNum;
                while R>0 do begin
                        if Pos('("',FP.Lines[R]) <> 3 then begin
                                ServerType:=FP.Lines[R];
                                Break;
                        end;
                dec(R);
                end;
                AddToTotal(ServerType);         
                if Result <> '' then
                        Result:= Result +' or '+ ServerType
                else
                        Result:=ServerType;
                end;
//***
        end;

NotYetFound:
end;
//end;
FoundServerType:
{Result:='';
if Found=True then begin
        // Ime Servera
        if Found=True then begin
                I:=LineNum;
                while I>0 do begin
                        if Pos('("',FP.Lines[I]) <> 3 then begin
                                ServerType:=FP.Lines[I];
                                Break;
                        end;
                dec(I);
                end;
        end;
        Result:= ServerType;
end else begin}
        if VerboseBox.Checked then begin
        AnswerMemo.Lines.Add('Suggestion');
        if Pos('T',TNum)=1 then begin

                        S:=Tnum+'(';
                for i:=0 to AnsHeaders.Count-1 do
                        if S <> Tnum+'(' then
                                S:=S+',"'+AnsHeaders[i]+'"'
                        else
                                S:=S+'"'+AnsHeaders[i]+'"';
                        S:=S+')';
                ANswerMemo.Lines.Add(S);
        end else begin
                        S:=Tnum+'(';
                        if S <> Tnum+'(' then
                                S:=S+',"'+A+'"'
                        else
                                S:=S+'"'+A+'"';
                        S:=S+')';
                ANswerMemo.Lines.Add(S);
        end;
        end;
// ***
// ***
end;
//end;
procedure TfrmMain.ScanBtnClick(Sender: TObject);
begin
Host:=AdrEdt.Text;
FingerPrintThread.Create(False);
end;

procedure TfrmMain.FingerPrintConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
StatusBar.SimpleText:='Connected';
end;

procedure TfrmMain.FingerPrintRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
V,A,T,Text: String;
I: Integer;
Found: Boolean;
begin
Text:=Socket.ReceiveText;
Delete(Text,Pos(#13#10#13#10,Text),Length(Text)-Pos(#13#10#13#10,Text)+1);
StatusBar.SimpleText:='Received '+IntToStr(Socket.ReceiveLength)+' bytes';
for i:=0 to FP.Lines.Count-1 do
        if Pos('^',FP.Lines[I])=1 then
                V:=CheckHeaders(Text,FP.Lines[I]);
T:=CheckHeaders(Text,'T'+IntToStr(CheckNum));
A:=CheckHeaders(Text,'A'+IntToStr(CheckNum));
inc(N_of_tests,2);
if VerboseBox.Checked then begin
        if T <> '' then begin
                AnswerMemo.Lines.Add('T'+IntToStr(Checknum)+' --> ' + T);
        end;

        if A <> '' then begin
                AnswerMemo.Lines.Add('A'+IntToStr(Checknum)+' --> ' + A);
        end;
        if VerboseBox.Checked then begin
                AnswerMemo.Lines.Add('****** ' + FingerPrint.Host + ':' + IntToStr(FingerPrint.Port) + '******');
                AnswerMemo.Lines.Add(Text);
                AnswerMemo.Lines.Add('********************');
        end;
end;
FingerPrint.Close;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
CheckNum:=0;
FP.Lines.LoadFromFile('fingerprints.txt');
LogMemo.Lines.LoadFromFile('checks.txt');
end;

procedure TfrmMain.FingerPrintWrite(Sender: TObject;
  Socket: TCustomWinSocket);
var
Request: String;
begin
if CheckNum < LogMemo.Lines.Count then begin
        Request:=LogMemo.Lines[CheckNum];
        if LocationEdt.Text = '' then
                Socket.SendText(Request+#13#10+'Host: ' + FingerPrint.Host+#13#10#13#10)
        else begin
                Insert(LocationEdt.Text+' ',Request,Pos(' / ',Request)+2);
                Socket.SendText(LogMemo.Lines[CheckNum]+#13#10+'Host: ' + FingerPrint.Host+#13#10#13#10);
        end;
        StatusBar.SimpleText:='SentData';
        inc(CheckNum);
end else begin
        Socket.Close;
        Timer1.Enabled:=False;
end;
end;

procedure TfrmMain.Button1Click(Sender: TObject);
begin
N_of_tests:=0;
CHeckNUm:=0;
AnswerMemo.Clear;
HeaderT:=TStringList.Create;
HeaderCnt:=TStringList.Create;
FingerPrint.Active:=False;
FingerPrint.Host:=AdrEdt.Text;
FingerPrint.Port:=StrToIntDef(PortEdt.Text,80);
FingerPrint.Open;
end;

procedure TfrmMain.FingerPrintDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
I,Max,Index: Integer;
S: String;
begin
if CheckNum < LogMemo.Lines.Count then
        Timer1.Enabled:=True
else begin
        Timer1.Enabled:=False;
        for i:=0 to HeaderT.Count-1 do
                if StrToInt(HeaderCnt[I])>Max then  begin
                        Index:=I;
                        Max:=StrToInt(HeaderCnt[I]);
                        S:=HeaderT[Index];
                end else
                if StrToInt(HeaderCnt[I])=Max then
                        S:=S+' or ' +HeaderT[I];
{                if Max < 4 then
                        AnswerMemo.Lines.Add('Result (not so sure, less then 4 of 8 tests were positive): '+S)
                else}
                        AnswerMemo.Lines.Add('Result ('+IntToStr(Max)+' of '+IntToStr(N_of_tests)+ ' tests were positive): '+S);
end;
end;

procedure TfrmMain.SaveBtnClick(Sender: TObject);
begin
FP.Lines.SaveToFile('fingerprints.txt');
end;

procedure TfrmMain.ResetBtnClick(Sender: TObject);
begin
FP.Lines.LoadFromFile('fingerprints.txt');
end;

procedure TfrmMain.SaveCheckBtnClick(Sender: TObject);
begin
LogMemo.Lines.SaveToFile('checks.txt');
end;

procedure TfrmMain.Timer1Timer(Sender: TObject);
begin
if not FingerPrint.Active
        then FingerPrint.Active:=True;
end;

procedure TfrmMain.GraphClick(Sender: TObject);
var
I,Max,Index: Integer;
begin
CheckHeaders('adsadsa','^Server');
end;

procedure TfrmMain.FingerPrintError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
ErrorCode:=0;
Timer1.Enabled:=False;
FingerPrint.Close;
AnswerMemo.Lines.Add('Error: ' +  IntToStr(ErrorCode));
end;

end.
